<?php
namespace FM\Service;

use FM\Factory\MinhasTarefasFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;

class MinhasTarefasService {

    protected $MinhasTarefasFactory;
    protected $Environment;
    protected $newCode;

    public function __construct (MinhasTarefasFactory $MinhasTarefasFactory, Environment $Environment, NewCode $newCode) {
        $this->MinhasTarefasFactory         = $MinhasTarefasFactory;
        $this->Environment                  = $Environment;
        $this->newCode                      = $newCode;
    }
    // Funções da tela Lista de Tarefas
    public function getPlace() {
        $places = $this->MinhasTarefasFactory->getPlace();
        return $places;
    }

    public function getSituation() {
        $places = $this->MinhasTarefasFactory->getSituation();
        return $places;
    }

    public function getTaskScheduled($parametro, $parametroIds) {
        $param = ' WHERE F.NRFUNCIONARIO = '.$parametro['nr'];

        if ($parametro['selectPlace'] != '' && $parametro['selectPlace'] != null) {
             $param = $param." AND LC.NRLOCALCLIENTE = ".$parametro['selectPlace'];
        }
        if ($parametro['selectSituation'] != '' && $parametro['selectSituation'] != null) {
                $param = $param." AND CA.IDSITUACAOAGEND = ".$parametro['selectSituation'];
        }
        if ($parametro['TO_CHAR(CA.DTHORAAGEND,\'DD/MM/YYYY\')'] != '' && $parametro['TO_CHAR(CA.DTHORAAGEND,\'DD/MM/YYYY\')'] != null && strlen($parametro['TO_CHAR(CA.DTHORAAGEND,\'DD/MM/YYYY\')']) == 21) {
                $param = $param." AND TO_CHAR(CA.DTHORAAGEND,'DD/MM/YYYY') = ".$parametro['TO_CHAR(CA.DTHORAAGEND,\'DD/MM/YYYY\')'];
        }

        $usersIds = implode(',',$parametroIds); // Transforma o array em uma string com os ids

        $places = $this->MinhasTarefasFactory->taskScheduled($param, $usersIds);
        return $places;
    }

    // Funções da Tela Minhas Tarefas
    public function nextTaskCard($parametro) {
        $usersIds = implode(',',$parametro['usersIds']); // Transforma o array em uma string com os ids

        $nextTC = $this->MinhasTarefasFactory->nextTaskCard($usersIds);
        return $nextTC;
    }

    public function changeStatusTask($params) {

        $parametros = array(
            "IDSITUACAOAGEND"    => $params['button'],
            "DSJUSTCANCELAMENTO" => (isset($params["DSJUSTCANCELAMENTO"])) ? $params["DSJUSTCANCELAMENTO"] : null,
            "NRCHECKLISTAGEND"   => $params['NRTAREFAATIVA']
        );

        $changeST = $this->MinhasTarefasFactory->upStatusTask($parametros);

        if ($params['button'] == 4) {
            $changeST = $this->MinhasTarefasFactory->upFinishTask($params['NRTAREFAATIVA']);
        }
    }

    // Funções da Tela de Detalhamento
    public function getDetailsTask($params) {

        $parametros = array(
            "NRCHECKLISTAGEND"    => $params['nr'],
        );

        $details = $this->MinhasTarefasFactory->cardDetailsTask($parametros);
        return $details;
    }

    public function getItensDetailsTask($params) {

        $parametros = array(
            "NRCHECKLISTAGEND"    => $params['nr'],
        );

        $details = $this->MinhasTarefasFactory->itensDetailsTask($parametros);
        return $details;
    }

    public function statusCheck($params) {
        
        $status = $this->MinhasTarefasFactory->statusCheck($params);
        return $status;
    }

    public function finishTaskDetails($params) {

        $parametros = array(
            "IDSITUACAOAGEND"    => 4,
            "DSJUSTCANCELAMENTO" => NULL,
            "NRCHECKLISTAGEND"   => $params['NRTAREFAATIVA']
        );

        $changeST = $this->MinhasTarefasFactory->upStatusTask($parametros);

        forEach($params['CHKBOX'] as $checkbox) {
           $parametros = array (
                "NRCHECKLISTAGEND"   => $params['NRTAREFAATIVA'],
                "NRTAREFAAGEND" => $checkbox
             );
            $this->MinhasTarefasFactory->upFinishDetailsTaks($parametros);
        }
    }
}
?>
