/* eslint-disable no-console */
import {
  Metadata,
} from '@zeedhi/core';
import {
  Button, Text,
} from '@zeedhi/common';

export class ControllerSensores {
  private contador: any;

  public iniciarContagem({ component }: any) {
    component.disabled = true;
    Metadata.getInstance<Button>('btnInterromperContador').disabled = false;
    if (window.location.pathname === '/SentidoUnico') {
      this.contagemSentidoUnico();
    } else if (window.location.pathname === '/SentidoDuplo') {
      this.contagemSentidoDuplo();
    } else if (window.location.pathname === '/SentidoGeral') {
      this.contagemSentidoGeral();
    }
  }

  public contagemSentidoUnico() {
    this.contador = setInterval(() => {
      const valorEntrada = Metadata.getInstance<Text>('ValorPlacarEntrada');
      valorEntrada.text = String(Number(valorEntrada.text) + 2);

      const valorSaida = Metadata.getInstance<Text>('ValorPlacarSaida');
      valorSaida.text = String(Number(valorSaida.text) + 1);

      const valorOcupacao = Metadata.getInstance<Text>('ValorPlacarOcupacao');
      valorOcupacao.text = String(Number(valorEntrada.text) - Number(valorSaida.text));
    }, 1000);
  }

  public contagemSentidoDuplo() {
    this.contador = setInterval(() => {
      const valorEntrada = Metadata.getInstance<Text>('ValorPlacarEntradaSaida');
      valorEntrada.text = String(Number(valorEntrada.text) + 1);

      const valorOcupacao = Metadata.getInstance<Text>('ValorPlacarOcupacao');
      valorOcupacao.text = String(Math.ceil(Number(valorEntrada.text) / 2));
    }, 1000);
  }

  public contagemSentidoGeral() {
    this.contador = setInterval(() => {
      const valorEntrada = Metadata.getInstance<Text>('ValorPlacarFluxo');
      valorEntrada.text = String(Number(valorEntrada.text) + 1);
    }, 1000);
  }

  public encerrarContagem({ component }: any) {
    component.disabled = true;
    Metadata.getInstance<Button>('btnIniciarContador').disabled = false;
    clearInterval(this.contador);
  }
}
